chiark / gitweb /
tg.sh: Check for read permissions of help files
[topgit.git] / tg.sh
diff --git a/tg.sh b/tg.sh
index c334f70ee420797c3de7b00ea293da5fefedd061..ead236154cc023c554638abe7503e0b8b3704148 100644 (file)
--- a/tg.sh
+++ b/tg.sh
@@ -21,11 +21,10 @@ die()
 setup_hook()
 {
        hook_call="\"\$(tg --hooks-path)\"/$1 \"\$@\""
-       if [ -x "$git_dir/hooks/$1" ]; then
-               if fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
-                       # Another job well done!
-                       return
-               fi
+       if [ -f "$git_dir/hooks/$1" ] &&
+          fgrep -q "$hook_call" "$git_dir/hooks/$1"; then
+               # Another job well done!
+               return
        fi
        # Prepare incanation
        if [ -x "$git_dir/hooks/$1" ]; then
@@ -37,7 +36,7 @@ setup_hook()
        {
                echo "#!/bin/sh"
                echo "$hook_call"
-               [ -x "$git_dir/hooks/$1" ] && cat "$git_dir/hooks/$1"
+               [ ! -s "$git_dir/hooks/$1" ] || cat "$git_dir/hooks/$1"
        } >"$git_dir/hooks/$1+"
        chmod a+x "$git_dir/hooks/$1+"
        mv "$git_dir/hooks/$1+" "$git_dir/hooks/$1"
@@ -86,32 +85,48 @@ branch_contains()
 # to the branch (e.g. B_DIRTY B1 B2 NAME), one path per line,
 # inner paths first. Innermost name can be ':' if the head is
 # not in sync with the base.
+# It will also return non-zero status if NAME needs update.
+# If needs_update() hits missing dependencies, it will append
+# them to space-separated $missing_deps list and skip them.
 needs_update()
 {
-       {
-       git cat-file blob "$1:.topdeps" 2>/dev/null |
-               while read _dep; do
-                       _dep_is_tgish=1
-                       git rev-parse --verify "refs/top-bases/$_dep" >/dev/null 2>&1 ||
-                               _dep_is_tgish=
-
-                       # Shoo shoo, keep our environment alone!
-                       [ -z "$_dep_is_tgish" ] || (needs_update "$_dep" "$@")
-
-                       _dep_base_uptodate=1
-                       if [ -n "$_dep_is_tgish" ]; then
-                               branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_uptodate=
-                       fi
-
-                       if [ -z "$_dep_base_uptodate" ]; then
-                               # _dep needs to be synced with its base
-                               echo ": $_dep $*"
-                       elif ! branch_contains "refs/top-bases/$1" "$_dep"; then
-                               # Some new commits in _dep
-                               echo "$_dep $*"
-                       fi
-               done
-       } || : # $1 is not tracked by TopGit anymore
+       depsfile="$(mktemp)"
+       git cat-file blob "$1:.topdeps" >"$depsfile"
+       _ret=0
+       while read _dep; do
+               if ! git rev-parse --verify "$_dep" >/dev/null 2>&1; then
+                       # All hope is lost
+                       missing_deps="$missing_deps $_dep"
+                       continue
+               fi
+
+               _dep_is_tgish=1
+               git rev-parse --verify "refs/top-bases/$_dep" >/dev/null 2>&1 ||
+                       _dep_is_tgish=
+
+               # Shoo shoo, keep our environment alone!
+               [ -z "$_dep_is_tgish" ] ||
+                       (needs_update "$_dep" "$@") ||
+                       _ret=$?
+
+               _dep_base_uptodate=1
+               if [ -n "$_dep_is_tgish" ]; then
+                       branch_contains "$_dep" "refs/top-bases/$_dep" || _dep_base_uptodate=
+               fi
+
+               if [ -z "$_dep_base_uptodate" ]; then
+                       # _dep needs to be synced with its base
+                       echo ": $_dep $*"
+                       _ret=1
+               elif ! branch_contains "refs/top-bases/$1" "$_dep"; then
+                       # Some new commits in _dep
+                       echo "$_dep $*"
+                       _ret=1
+               fi
+       done <"$depsfile"
+       missing_deps="${missing_deps# }"
+       rm "$depsfile"
+       return $_ret
 }
 
 # branch_empty NAME
@@ -133,6 +148,32 @@ switch_to_base()
        git symbolic-ref HEAD "$_base"
 }
 
+# Show the help messages.
+do_help()
+{
+       if [ -z "$1" ] ; then
+               ## Build available commands list for help output
+
+               cmds=
+               sep=
+               for cmd in "@cmddir@"/tg-*; do
+                       ! [ -r "$cmd" ] && continue
+                       # strip directory part and "tg-" prefix
+                       cmd="$(basename "$cmd")"
+                       cmd="${cmd#tg-}"
+                       cmds="$cmds$sep$cmd"
+                       sep="|"
+               done
+
+               echo "TopGit v0.1 - A different patch queue manager"
+               echo "Usage: tg ($cmds|help) ..."
+       elif [ -r "@sharedir@/tg-$1.txt" ] ; then
+               cat "@sharedir@/tg-$1.txt"
+       else
+               echo "`basename $0`: no help for $1" 1>&2
+       fi
+}
+
 
 ## Initial setup
 
@@ -143,6 +184,8 @@ root_dir="$(git rev-parse --show-cdup)"; root_dir="${root_dir:-.}"
 setup_ours
 setup_hook "pre-commit"
 
+[ -d "@cmddir@" ] ||
+       die "No command directory: '@cmddir@'"
 
 ## Dispatch
 
@@ -156,15 +199,15 @@ shift
 
 case "$cmd" in
 help)
-       echo "TopGit v0.1 - A different patch queue manager"
-       echo "Usage: tg (create|delete|info|patch|summary|update|help) ..."
+       do_help "$1"
        exit 1;;
-create|delete|info|patch|summary|update)
-       . "@cmddir@"/tg-$cmd;;
 --hooks-path)
        # Internal command
        echo "@hooksdir@";;
 *)
-       echo "Unknown subcommand: $cmd" >&2
-       exit 1;;
+       [ -r "@cmddir@"/tg-$cmd ] || {
+               echo "Unknown subcommand: $cmd" >&2
+               exit 1
+       }
+       . "@cmddir@"/tg-$cmd;;
 esac